<template>
    <q-page class="flex">
      <div class="login-card">
        <el-form :model="login" :rules="rules" ref="login" label-position="left" label-width="0px" class="demo-ruleForm login-container">
          <h4 class="title">Agent Management System</h4>
            <el-form-item prop="username">
              <el-input type="text" v-model="login.username" auto-complete="off" placeholder="Username"></el-input>
            </el-form-item>
            <el-form-item prop="password">
              <el-input type="password" v-model="login.password" auto-complete="off" placeholder="Password" @keyup.native.enter="submit()"></el-input>
            </el-form-item>
            <el-form-item style="width:100%;">
              <q-btn color="primary" @click="submit()" >Login</q-btn>
            </el-form-item>
        </el-form>
      </div>
    </q-page>
</template>

<script>
import { QSpinnerGears } from 'quasar'
import 'element-ui/lib/theme-chalk/index.css'
export default {
  name: 'Login',
  data() {
    return {
      logining: false,
      login: {
        username: '',
        password: ''
      },
      rules: {
        username: [
          { required: true, message: 'Please input Activity email address', trigger: 'blur' },
          // { type: 'email', message: 'Please input correct email address', trigger: ['blur', 'change'] }
        ],
        password: [
          { required: true, message: 'Please input Activity password', trigger: 'blur' },
        ]
      }
    }
  },

  methods: {
    submit () {
      this.$q.loading.show({
        spinner: QSpinnerGears,
        spinnerColor: 'primary',
        message: 'loading......'
      })
      let ctx = this
      this.$refs.login.validate((valid) => {
        if(valid){
          this.$services.member.authenticate(this.login)
          .then(function (data) {
            data.user_permissions.report = ['report']
            ctx.$q.sessionStorage.set('key', data.key)
            ctx.$q.sessionStorage.set('permissions', data.user_permissions)
            ctx.$q.sessionStorage.set('username', data.username)
            ctx.$q.sessionStorage.set('credit', data.credit)
            ctx.$q.sessionStorage.set('role', data.role)
            ctx.$q.loading.hide();
            ctx.$router.push({ name: 'index' })
          })
          .catch (function(e) {
            ctx.$q.loading.hide();
            ctx.$services.error(e.response)
          })
        }
      })
    }
  }
}
</script>

<style >
  .login-container {
    -webkit-border-radius: 5px;
    border-radius: 5px;
    -moz-border-radius: 5px;
    background-clip: padding-box;
    margin: 180px auto;
    width: 430px;
    padding: 35px 35px 15px 35px;
    background: #fff;
    border: 1px solid #eaeaea;
    box-shadow: 0 0 25px #cac6c6;
  }
  .login-container .title {
    margin: 0 auto 40px;
    text-align: center;
    color: #505458;
  }
  .remember {
    margin: 0px 0px 35px 0px;
  }
  .el-input__inner {
    width: 100%;
    height: 36px;
    line-height: 20px;
    /* font-size: 14px; */
    border-radius: 3px;
    border: 1px solid #b7b7b7;
    text-indent: 5px;
    background-color: #FFF;
    -webkit-box-shadow: inset 0px 0px 4px 0px rgba(0,0,0,0.35);
    -moz-box-shadow: inset 0px 0px 4px 0px rgba(0,0,0,0.35);
    box-shadow: inset 0px 0px 4px 0px rgba(0,0,0,0.35);
  }
  .login-card {
    text-align: center;
    position: relative;
  }
</style>
